/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ca.mcscert.jtet.expression;

/**
 *
 * @author matthew
 */
public final class ExpressionUnaryOperation implements Expression, ExpressionWithSubExpression {

    public ExpressionUnaryOperation(UnaryOperation op, Expression rhs) {
        m_expr = rhs;
        m_op = op;
    }

    void setExpression(Expression expr) {
        m_expr = expr;
    }

    @Override
    public VariableType actualOutputTypeForRequestedOutput(VariableTypeMarker requestedType) {
        return m_expr.actualOutputTypeForRequestedOutput(requestedType);
    }

    @Override
    public String getCheckerOutput(CheckerGenerator generator, VariableType requestedType) {
        if (actualOutputTypeForRequestedOutput(requestedType) == null) {
            throw new IllegalArgumentException("Can generate output for requested type!");
        }

        String expression = m_expr.getCheckerOutput(generator, requestedType);

        return generator.GenerateUnaryOperation(m_op, expression, requestedType);
    }

    @Override
    public Expression getSubExpression() {
        return m_expr;
    }

    @Override
    public void setSubExpression(Expression subExpression) {
        m_expr = subExpression;
    }

    @Override
    public String toString() {
        return "( " + m_op + " " + m_expr + ")";
    }

    private Expression m_expr;
    private UnaryOperation m_op;
}
