/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ca.mcscert.jtet.expression.test;

import ca.mcscert.jtet.expression.CVC3Generator;
import ca.mcscert.jtet.expression.CheckerGenerator;
import ca.mcscert.jtet.expression.FixedPointVariableType;
import ca.mcscert.jtet.expression.Literal;
import ca.mcscert.jtet.expression.RealVariableType;
import ca.mcscert.jtet.expression.VariableType;
import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.runner.RunWith;
import org.junit.runners.JUnit4;

/**
 *
 * @author matthew
 */
@RunWith(JUnit4.class)
public class MatlabLiteralTest {
    /**
     * Test of canHandleOutputType method, of class Literal.
     */
    @Test
    public void testType() {
        Literal instance = new Literal(null);
        VariableType exprType = RealVariableType.Type;
        assertEquals(exprType, instance.actualOutputTypeForRequestedOutput(exprType));
    }

    /**
     * Test of getCVC3Output method, of class Literal.  Test only natural numbers;
     */
    @Test
    public void testGetCVC3Output() {
        Literal instance = new Literal("5");
        assertEquals("5", instance.getCheckerOutput(generator, RealVariableType.Type));
        assertEquals("0bin00101", instance.getCheckerOutput(generator, new FixedPointVariableType(true, 5, 0)));
        assertEquals("0bin01010", instance.getCheckerOutput(generator, new FixedPointVariableType(true, 5, 1)));
    }

    /**
     * Test of getCVC3Output method, of class Literal.  Test fun fixed point number;
     */
    @Test
    public void testCVC3OutputOnInterestingFixedPoint() {
        Literal instance = new Literal("0");
        assertEquals("0bin00000", instance.getCheckerOutput(generator, new FixedPointVariableType(true, 5, 1)));
        
        instance = new Literal("5.5");
        assertEquals("0bin01011", instance.getCheckerOutput(generator, new FixedPointVariableType(true, 5, 1)));
        
        instance = new Literal("-5.5");
        assertEquals("0bin10101", instance.getCheckerOutput(generator, new FixedPointVariableType(true, 5, 1)));
        
        instance = new Literal("-5");
        assertEquals("0bin11011", instance.getCheckerOutput(generator, new FixedPointVariableType(true, 5, 0)));
    }
    CheckerGenerator generator = new CVC3Generator();
}
